<?php
/*
 *Name         : query.php
 *Author       : Michael Yara
 *Created      : June 15, 2008
 *Last Updated : Dec 2, 2009
 *History      : 0.2
 *Purpose      : Contains an example of querying some of the configuration tree and printing. 
 *Copyright    : 2008 HEHE Enterprises, LLC
 */

error_reporting(E_ALL);

include("../isymphony.php");

if(!iSymphonyConnect()) {
	echo $ISERROR;
	die;
}

echo "(Server)<br>";
if(($object = getISymphonyServer()) !== false) {
	var_dump($object);
} else {
	echo $ISERROR;
	die;
}

//Locations-------------------------------------------------
if(($locarray = getISymphonyLocationList()) !== false) {
	
	foreach($locarray as $locval) {
		
		if(($locobject = getISymphonyLocation($locval)) !== false) {
			
			echo "Location \"$locval\"<br>";
			var_dump($locobject);
			
			//Tenants-----------------------------------------------
			if(($tenarray = getISymphonyTenantList($locval)) !== false) {
				
				foreach($tenarray as $tenval) {
					
					if(($tenobject = getISymphonyTenant($locval, $tenval)) !== false) {
						
						echo "Tenant \"$tenval\"<br>";
						var_dump($tenobject);
						
						//Extensions-------------------------------------------------
						if(($extarray = getISymphonyExtensionList($locval,$tenval)) !== false) {
							
							foreach($extarray as $extval) {
								
								if(($extobject = getISymphonyExtension($locval, $tenval, $extval)) !== false) {
									
									echo "Extension \"$extval\"<br>";
									var_dump($extobject);
									
								} else {
									echo $ISERROR;
									die;
								}
							}
						} else {
							echo $ISERROR;
							die;
						}
						
						//Profiles-------------------------------------------------
						if(($proarray = getISymphonyProfileList($locval,$tenval)) !== false) {
							
							foreach($proarray as $proval) {
								
								if(($proobject = getISymphonyProfile($locval, $tenval, $proval)) !== false) {
									
									echo "Profile \"$proval\"<br>";
									var_dump($proobject);
									
								} else {
									echo $ISERROR;
									die;
								}
							}
						} else {
							echo $ISERROR;
							die;
						}
						
						//Queues-------------------------------------------------
						if(($quearray = getISymphonyQueueList($locval,$tenval)) !== false) {
							
							foreach($quearray as $queval) {
								
								if(($queobject = getISymphonyQueue($locval, $tenval, $queval)) !== false) {
									
									echo "Queue \"$queval\"<br>";
									var_dump($queobject);
									
								} else {
									echo $ISERROR;
									die;
								}
							}
						} else {
							echo $ISERROR;
							die;
						}
						
						//Conference rooms-------------------------------------------------
						if(($confarray = getISymphonyConferenceRoomList($locval,$tenval)) !== false) {
							
							foreach($confarray as $confval) {
								
								if(($confobject = getISymphonyConferenceRoom($locval, $tenval, $confval)) !== false) {
									
									echo "Room \"$confval\"<br>";
									var_dump($confobject);
									
								} else {
									echo $ISERROR;
									die;
								}
							}
						} else {
							echo $ISERROR;
							die;
						}
					}
				}
			} else {
				echo $ISERROR;
				die;
			}	
		} else {
			echo $ISERROR;
			die;
		}	
	}
} else {
	echo $ISERROR;
	die;
}

if(!iSymphonyDisconnect()) {
	echo $ISERROR;
	die;
}
?>