<?php
/*
 *Name         : property_arrays.php
 *Author       : Michael Yara
 *Created      : June 15, 2008
 *Last Updated : Dec 15, 2010
 *History      : 0.2
 *Purpose      : Contains arrays witch describe all configuration object property names along with functions to modify
 *				 the arrays for specific versions of the server. 
 *Copyright    : 2008 HEHE Enterprises, LLC
 */

$serverPropertyArray = array("client_port","cli_port","username","password");
$locationPropertyArray = array("name","admin_password","asterisk_host","asterisk_port","asterisk_login","asterisk_password","originate_timeout","jabber_host","jabber_port");
$tenantPropertyArray = array("name","admin_password","originating_context","redirecting_context","music_on_hold_class","outside_line_number","record_file_name","record_file_extension","mix_mode");
$extensionPropertyArray = array("extension_val","name","cell_phone","email","peer","alt_origination_method","voice_mail","agent");
$profilePropertyArray = array("name","password","jabber_user_name","jabber_password","can_view_everyone_directory");
$queuePropertyArray = array("name","queue_val","extension_val","context");
$conferenceRoomPropertyArray = array("name","predefined","room_number","extension_val","context","announce_user_count","music_on_hold_for_single_user","exit_room_via_pound","present_menu_via_star","announce_user_join_leave","disable_join_leave_notification","record");
$permissionGroupPropertyArray = array("name");
$statusPropertyArray = array("name","type");
$localPermissionPropertyArray = array("call_voice_mail","hold_calls","transfer_call_to_voice_mail","mute","record","hangup","set_user_status_note","call_cell_phone","add_extension_directory","set_user_status","transfer_call_to_cell_phone","agent_login","add_temp_meetme_room");
$remotePermissionPropertyArray = array("call_voice_mail","transfer_to","transfer_call_to_voice_mail","steal_call","record","originate_to","email","call_cell_phone","barge","transfer_call_to_cell_phone","chat","agent_login","view_calls","view_caller_id");
$parkPermissionPropertyArray = array("park_call","set_parked_call_note","unpark_call");
$queuePermissionPropertyArray = array("transfer_to","steal_call");
$conferenceRoomPermissionPropertyArray = array("steal_call","transfer_to","originate_to","mute_users","kick_users");
$updateStatePropertyArray = array("task","message","work","work_done");

//Property array modification functions--------------------------------------------------------------------------------------------------------------
function isymphony_reset_property_arrays() {
	global	$serverPropertyArray, $locationPropertyArray, $tenantPropertyArray, $extensionPropertyArray, $profilePropertyArray, $queuePropertyArray,
			$conferenceRoomPropertyArray, $permissionGroupPropertyArray, $statusPropertyArray, $localPermissionPropertyArray, $remotePermissionPropertyArray, 
			$parkPermissionPropertyArray, $queuePermissionPropertyArray, $conferenceRoomPermissionPropertyArray, $updateStatePropertyArray; 
			
	$serverPropertyArray = array("client_port","cli_port","username","password");
	$locationPropertyArray = array("name","admin_password","asterisk_host","asterisk_port","asterisk_login","asterisk_password","originate_timeout","jabber_host","jabber_port");
	$tenantPropertyArray = array("name","admin_password","originating_context","redirecting_context","music_on_hold_class","outside_line_number","record_file_name","record_file_extension","mix_mode");
	$extensionPropertyArray = array("extension_val","name","cell_phone","email","peer","alt_origination_method","voice_mail","agent");
	$profilePropertyArray = array("name","password","jabber_user_name","jabber_password","can_view_everyone_directory");
	$queuePropertyArray = array("name","queue_val","extension_val","context");
	$conferenceRoomPropertyArray = array("name","predefined","room_number","extension_val","context","announce_user_count","music_on_hold_for_single_user","exit_room_via_pound","present_menu_via_star","announce_user_join_leave","disable_join_leave_notification","record");
	$permissionGroupPropertyArray = array("name");
	$statusPropertyArray = array("name","type");
	$localPermissionPropertyArray = array("call_voice_mail","hold_calls","transfer_call_to_voice_mail","mute","record","hangup","set_user_status_note","call_cell_phone","add_extension_directory","set_user_status","transfer_call_to_cell_phone","agent_login","add_temp_meetme_room");
	$remotePermissionPropertyArray = array("call_voice_mail","transfer_to","transfer_call_to_voice_mail","steal_call","record","originate_to","email","call_cell_phone","barge","transfer_call_to_cell_phone","chat","agent_login","view_calls","view_caller_id");
	$parkPermissionPropertyArray = array("park_call","set_parked_call_note","unpark_call");
	$queuePermissionPropertyArray = array("transfer_to","steal_call");
	$conferenceRoomPermissionPropertyArray = array("steal_call","transfer_to","originate_to","mute_users","kick_users");
	$updateStatePropertyArray = array("task","message","work","work_done");
}

function isymphony_modify_property_arrays_2_1() {
	global $locationPropertyArray, $extensionPropertyArray, $tenantPropertyArray;
	
	//New modifications
	array_push($locationPropertyArray, "device_user_mode");
	
	array_push($tenantPropertyArray, "page_status_enabled");
	array_push($tenantPropertyArray, "page_context");
	
	$extensionPropertyArray = remove_element($extensionPropertyArray, "agent");
}

function isymphony_modify_property_arrays_2_1_1489() {
	global $locationPropertyArray, $extensionPropertyArray, $tenantPropertyArray, $profilePropertyArray;
	
	//Apply 2.1 modifications
	isymphony_modify_property_arrays_2_1();
	
	//New modifications
	array_push($locationPropertyArray, "reload_on_dial_plan_reload");
	array_push($locationPropertyArray, "jabber_domain");
	array_push($locationPropertyArray, "jabber_resource");
	
	array_push($profilePropertyArray, "jabber_host");
	array_push($profilePropertyArray, "jabber_domain");
	array_push($profilePropertyArray, "jabber_resource");
	array_push($profilePropertyArray, "jabber_port");
}

function isymphony_modify_property_arrays_2_1_1493() {
	global $locationPropertyArray, $extensionPropertyArray, $tenantPropertyArray, $profilePropertyArray;
	
	//Apply 2.1 1489 modifications
	isymphony_modify_property_arrays_2_1_1489();
	
	//New modifications
	array_push($extensionPropertyArray, "auto_answer");
}

function isymphony_modify_property_arrays_2_1_1660() {
	global $locationPropertyArray, $extensionPropertyArray, $tenantPropertyArray, $profilePropertyArray;
	
	//Apply 2.1 1493 modifications
	isymphony_modify_property_arrays_2_1_1493();
	
	//New modifications
	array_push($tenantPropertyArray, "agent_login_context");
}

function isymphony_modify_property_arrays_2_1_1678() {
	global $serverPropertyArray, $locationPropertyArray, $extensionPropertyArray, $localPermissionPropertyArray, $remotePermissionPropertyArray, $queuePermissionPropertyArray;
	
	//Apply 2.1 1660 modifications
	isymphony_modify_property_arrays_2_1_1660();
	
	//New modifications
	array_push($serverPropertyArray, "hold_extension_button_enabled");
	array_push($serverPropertyArray, "park_extension_button_enabled");
	array_push($serverPropertyArray, "record_extension_button_enabled");
	array_push($serverPropertyArray, "hangup_extension_button_enabled");
	array_push($serverPropertyArray, "cell_phone_extension_button_enabled");
	array_push($serverPropertyArray, "voice_mail_extension_button_enabled");
	array_push($serverPropertyArray, "agent_extension_button_enabled");
	array_push($serverPropertyArray, "email_extension_button_enabled");
	array_push($serverPropertyArray, "chat_extension_button_enabled");
	array_push($serverPropertyArray, "mute_extension_button_enabled");
	array_push($serverPropertyArray, "barge_extension_button_enabled");
	
	array_push($locationPropertyArray, "mask_jabber_user_name_with_profile");
	array_push($locationPropertyArray, "force_client_update");
	array_push($locationPropertyArray, "voice_mail_directory");
	
	array_push($extensionPropertyArray, "voice_mail_context");
	array_push($extensionPropertyArray, "originating_context");
	array_push($extensionPropertyArray, "redirecting_context");
	array_push($extensionPropertyArray, "agent_login_context");
	array_push($extensionPropertyArray, "music_on_hold_class");
	
	array_push($localPermissionPropertyArray, "listen_to_voice_mail");
	array_push($localPermissionPropertyArray, "delete_voice_mail");
	array_push($localPermissionPropertyArray, "move_voice_mail");
	array_push($localPermissionPropertyArray, "pause_member");
	
	array_push($remotePermissionPropertyArray, "forward_voice_mail_to");
	array_push($remotePermissionPropertyArray, "set_user_status");
	array_push($remotePermissionPropertyArray, "set_user_status_note");
	array_push($remotePermissionPropertyArray, "pause_member");
	
	array_push($queuePermissionPropertyArray, "dynamic_login");
}

function isymphony_modify_property_arrays_2_1_1706() {
	
	global $serverPropertyArray;
	
	//Apply 2.1 1678 modifications
	isymphony_modify_property_arrays_2_1_1678();
	
	//New modifications
	array_push($serverPropertyArray, "http_port");
	array_push($serverPropertyArray, "update_site_url");
}

function isymphony_modify_property_arrays_2_1_1736() {
	
	global $locationPropertyArray;
	
	//Apply 2.1 1706 modifications
	isymphony_modify_property_arrays_2_1_1706();
	
	//New modifications
	array_push($locationPropertyArray, "log_jabber_messages");
}

function isymphony_modify_property_arrays_2_2_1957() {
	
	global $extensionPropertyArray, $queuePermissionPropertyArray, $conferenceRoomPermissionPropertyArray;
	
	//Apply 2.1 1736 modifications
	isymphony_modify_property_arrays_2_1_1736();
	
	//New modifications
	array_push($extensionPropertyArray, "agent_login_interface");
	array_push($extensionPropertyArray, "agent_login_penalty");
	array_push($queuePermissionPropertyArray, "display");
	array_push($conferenceRoomPermissionPropertyArray, "display");
}

function isymphony_modify_property_arrays_2_2_2041() {
	
	global $profilePropertyArray;
	
	//Apply 2.2 1957 modifications
	isymphony_modify_property_arrays_2_2_1957();
	
	//New modifications
	array_push($profilePropertyArray, "unregistered_color");
	array_push($profilePropertyArray, "registered_color");
	array_push($profilePropertyArray, "ringing_color");
	array_push($profilePropertyArray, "pending_color");
	array_push($profilePropertyArray, "local_linked_color");
	array_push($profilePropertyArray, "outside_linked_color");
	array_push($profilePropertyArray, "queue_linked_color");
}

function isymphony_modify_property_arrays_2_2_2096() {
	
	global $profilePropertyArray;
	
	//Apply 2.2 2041 modifications
	isymphony_modify_property_arrays_2_2_2041();
	
	//New modifications
	array_push($profilePropertyArray, "chan_spy_barge");
}

function isymphony_modify_property_arrays_2_2_2124() {
	
	global $serverPropertyArray;
	
	//Apply 2.2 2096 modifications
	isymphony_modify_property_arrays_2_2_2096();
	
	//New modifications
	array_push($serverPropertyArray, "do_not_disturb_extension_button_enabled");
}

function isymphony_modify_property_arrays_2_2_2174() {
	
	global $conferenceRoomPropertyArray;
	
	//Apply 2.2 2124 modifications
	isymphony_modify_property_arrays_2_2_2124();
	
	//New modifications
	array_push($conferenceRoomPropertyArray, "peer_originate");
}

function isymphony_modify_property_arrays_2_2_2203() {
	
	global $extensionPropertyArray;
	
	//Apply 2.2 2174 modifications
	isymphony_modify_property_arrays_2_2_2174();
	
	//New modifications
	array_push($extensionPropertyArray, "agent_login_name");
}

function isymphony_modify_property_arrays_2_2_2205() {
	
	global $tenantPropertyArray;
	
	//Apply 2.2 2203 modifications
	isymphony_modify_property_arrays_2_2_2203();
	
	//New modifications
	array_push($tenantPropertyArray, "ringing_status_enabled");
}

function isymphony_modify_property_arrays_2_2_2257() {
	
	global $locationPropertyArray, $remotePermissionPropertyArray, $localPermissionPropertyArray;
	
	//Apply 2.2 2205 modifications
	isymphony_modify_property_arrays_2_2_2205();
	
	//New modifications
	array_push($locationPropertyArray, "use_voice_mail_agent");
	array_push($locationPropertyArray, "voice_mail_agent_host");
	array_push($locationPropertyArray, "voice_mail_agent_port");
	array_push($locationPropertyArray, "voice_mail_agent_user_name");
	array_push($locationPropertyArray, "voice_mail_agent_password");

	array_push($remotePermissionPropertyArray, "do_not_disturb");
	array_push($localPermissionPropertyArray, "do_not_disturb");
}
?>