#!/bin/bash
#
# *** BEGIN HEADER ****
# This file and it's contents copyright 2006
# i9 Technologies. http://www.i9technologies.com
# e-mail isymphony-support@i9technologies.com for 
# more information
#
# Maintainer(s):
# Arthur Heffern
#
# **** END HEADER ****

SERVERSCRIPTNAME=`ls -1 *Server.sh | head -n 1`
NAME=`echo ${SERVERSCRIPTNAME} | sed s/.sh//`
LCNAME=`echo ${SERVERSCRIPTNAME} | tr '[A-Z]' '[a-z]' | sed s/server// | sed s/.sh//`
LOCATION="/opt/${LCNAME}/server/";

if [ -e ${LOCATION}/config-vars.sh ]; then
    . ${LOCATION}/config-vars.sh
fi

if [ x${JAVA_HOME} = "x" ]; then
    echo "First, We need to know the path to your"
    echo "Sun Java installation [/usr/java/latest]:"
    read JAVAINSTALLPATH
fi

if [ x${JAVAINSTALLPATH} = "x" ]; then
    JAVA_HOME="/usr/java/latest"
else
    JAVA_HOME=${JAVAINSTALLPATH}
fi

echo "Checking for Java Binary ${JAVA_HOME}/bin/java.."

if [ ! -x ${JAVA_HOME}/bin/java ]; then
        echo "You do not appear to have the Sun Microsystems Java Runtime"
        echo "Environment (JRE) installed.  We could not find the java binary"
    echo "at:"
    echo ""
    echo "${JAVA_HOME}/bin/java"
        echo ""
        echo "This program will not function appropriately without J2SE"
        echo "1.5 Java 5 or greater."
        echo ""
    exit 1
fi

echo "Checking For DESTDIR.."

if [ -e /opt/${LCNAME}/server ]; then
    DESTDIR=/opt/${LCNAME}/server
fi

if [ x${DESTDIR} = "x" ]; then
    if [ x${INSTALLDIR} = "x" ]; then
        echo "Where would you like this package to be installed?"
        echo "[/opt/${LCNAME}/server]"
        read INSTALLPATHINPUT
    fi

    if [ x${INSTALLPATHINPUT} = "x" ]; then
        DESTDIR="/opt/${LCNAME}/server"
    else
        DESTDIR=${INSTALLPATHINPUT}
    fi
fi

echo "Configuration Complete, beginning install.."

WHOAMI=`whoami`

if [ ${WHOAMI} != "root" ]; then
    echo "You must be root to install this application"
    exit 1
fi

echo "Creating ${LCNAME} user.."
adduser ${LCNAME}

echo "Installing into ${DESTDIR}.."

if [ ! -d ${DESTDIR} ]; then
    echo "Creating install directory.."
    install -d -v --group=${LCNAME} --owner=${LCNAME} ${DESTDIR}
fi

echo "Installing packages.."
echo ""
if [ -e ${LOCATION}/${SERVERSCRIPTNAME} ]; then
    echo "Upgrade Installation Detected at ${LOCATION}.  Upgrading."
    for i in `find config  lic  config-vars.sh -type f`; do
        yes n | cp -ri $i ${DESTDIR}/${i}
    done
    for i in `ls -1 | grep -v config-vars.sh | grep -v config | grep -v lic | grep -v config-vars.sh`; do
        cp -r ${i} ${DESTDIR}
        chown -R ${LCNAME}:${LCNAME} ${DESTDIR}
    done;
    echo ""
elif [ -e ./${NAME}.jar ]; then
    for i in `ls -1`; do
        cp -r * ${DESTDIR}
        chown -R ${LCNAME}:${LCNAME} ${DESTDIR}
    done
    echo "JAVA_HOME=${JAVA_HOME}" > ${DESTDIR}/config-vars.sh
fi

chmod u+x ${DESTDIR}/*.sh
chmod u+x REDHAT-INIT-SCRIPT

echo "Done installing.."
echo ""
echo "### READ THIS!! ###"
echo ""
echo "Make sure you configure ${DESTDIR}/extensions.conf and" 
echo "${DESTDIR}/server.conf before starting the server."
echo ""
echo "If you want to activate or register your copy, run:"
echo "/bin/bash ${DESTDIR}/register.sh"
echo ""
echo "Or, for normal startup you may run:"
echo "/bin/bash ${DESTDIR}/startup.sh"
echo ""
