<?php
/*
 *Name         : status.php
 *Author       : Michael Yara
 *Created      : June 15, 2008
 *Last Updated : June 18, 2008
 *History      : 0.1 Beta  
 *Purpose      : Contains an example of updating and querying user status(This example is based off of elements created in build.php). 
 *Copyright    : 2008 HEHE Enterprises, LLC
 */

error_reporting(E_ALL);

include("../isymphony.php");

if(!iSymphonyConnect()) {
	echo $ISERROR;
	die;
}

echo "Setting status on extension 100<br>";
if(!setISymphonyExtensionStatus("default","default","100","Out to lunch")) {
	echo $ISERROR;
	die;	
}

echo "Setting note on extension 100<br>";
if(!setISymphonyExtensionNote("default","default","100","This is my note for extension 100.")) {
	echo $ISERROR;
	die;	
}

echo "Setting return time on extension 100<br>";
if(!setISymphonyExtensionReturnTime("default","default","100",strtotime("now"))) {
	echo $ISERROR;
	die;	
}

echo "Current status for extension 100=";
if(($reply = getISymphonyExtensionStatus("default","default","100")) !==false) {
	echo $reply . "<br>";
} else {
	echo $ISERROR;
	die;
}

echo "Current note for extension 100=";
if(($reply = getISymphonyExtensionNote("default","default","100")) !==false) {
	echo $reply . "<br>";
} else {
	echo $ISERROR;
	die;
}

echo "Current return time for extension 100=";
if(($reply = getISymphonyExtensionReturnTime("default","default","100")) !==false) {
	echo date("F j, Y, g:i a",$reply) . "<br>";
} else {
	echo $ISERROR;
	die;
}

if(!iSymphonyDisconnect()) {
	echo $ISERROR;
	die;
}