<?php
/*
 *Name         : upgrade.php
 *Author       : Michael Yara
 *Created      : Dec 2, 2009
 *Last Updated : Dec 2, 2009
 *History      : 0.1  
 *Purpose      : Contains an example of upgrading the server. 
 *Copyright    : 2009 HEHE Enterprises, LLC
 */

error_reporting(E_ALL);

include("../isymphony.php");

if(!iSymphonyConnect()) {
	echo $ISERROR;
	die;
}

//Check for available update
echo "Checking for upgrade<br>";
if(($return = checkForiSymphonyUpdates()) !== false) {

	//Check return value to see if an update is available. If so run the update.
	if(strpos("Update Available", $return) === 0) {
		echo "Update available: Updating now<br>";
		
		//Perform update on server
		iSymphonyUpdate();
		
		//Check server update status every second for 5 seconds
		for($i = 0; $i < 5; $i++) {
			
			sleep(1);
			
			if(($object = iSymphonyGetUpdateState()) !== false) {
				var_dump($object);
			} else {
				echo $ISERROR;
				die;
			}
		}
	} else {
		echo "No Update available<br>";
	}
} else {
	echo $ISERROR;
	die;
}

if(!iSymphonyDisconnect()) {
	echo $ISERROR;
	die;
}
?>